Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.flagstone.transform
Class FSVideoFrame

    java.lang.Object
      com.flagstone.transform.FSTransformObject
          com.flagstone.transform.FSMovieObject
              com.flagstone.transform.FSVideoFrame

All Implemented Interfaces:
  java.lang.Cloneable

    public class FSVideoFrame

extends FSMovieObject

FSVideoFrame contains the video data displayed in a single frame of a Flash movie.

Attributes
type | Identifies the data structure when it is encoded. Read-only.
identifier | The identifier of the FSDefineVideo object that defines the size of the images displayed.
frameNumber | The number of the frame that the data is for.
data | The encoded video data. Encoded using either the modified Sorenson H263 or Macromedia's Screen Video formats.

Each frame of video is displayed whenever display list is updated using the FSShowFrame object - any timing information stored within the video data is ignored. Since the video is updated at the same time as the display list the frame rate of the video may be the same or less than the frame rate of the Flash movie but not higher.

# History

The FSVideoFrame class represents the VideoFrame data structure in the Macromedia Flash (SWF) File Format Specification. It was added in Flash 6 with support for the Sorenson modified H263 format. Support for Macromedia's Screen Video format was added in Flash 7.

Field Summary

Fields inherited from class com.flagstone.transform.FSMovieObject
`ButtonColorTransform, ButtonSound, DefineBitsPtr, DefineButton, DefineButton2, DefineFont, DefineFont2, DefineImage, DefineImage2, DefineJPEGImage, DefineJPEGImage2, DefineJPEGImage3, DefineMorphShape, DefineMovieClip, DefineShape, DefineShape2, DefineShape3, DefineSound, DefineText, DefineText2, DefineTextField, DefineVideo, DoAction, EnableDebugger, EnableDebugger2, Export, extendLength, FontInfo, FontInfo2, FrameLabel, Free, Import, Initialize, JPEGTables, length, LimitScript, PathsArePostscript, PlaceObject, PlaceObject2, Protect, QuicktimeMovie, RemoveObject, RemoveObject2, SerialNumber, SetBackgroundColor, ShowFrame, SoundStreamBlock, SoundStreamHead, SoundStreamHead2, StartSound, TabOrder, type, VideoFrame`

Constructor Summary
`FSVideoFrame(FSCoder coder)` Construct an FSVideoFrame object, initialising it with values decoded from an encoded object.
`FSVideoFrame(FSVideoFrame obj)` Constructs an FSVideoFrame object by copying values from an existing object.
`FSVideoFrame(int anIdentifier, int frameNumber, byte[] data)` Constructs a new FSVideoFrame object which will display the specified frame of video data in the FSDefineVideo object that matches the identifier.

Method Summary
`void` | `appendDescription(java.lang.StringBuffer buffer, int depth)` AppendDescription is used to present a string description of the object including all nested objects up to a specified depth.
`java.lang.Object` | `clone()` Creates a deep copy of the entire object.
`void` | `decode(FSCoder coder)`
`void` | `encode(FSCoder coder)`
`boolean` | `equals(java.lang.Object anObject)` Returns true if anObject is equal to this one.
`byte[]` | `getData()` Gets the encoded video data.
`int` | `getFrameNumber()` Gets the number of the frame.
`int` | `getIdentifier()` Get the identifier of the FSDefineVideo object where the frame will be displayed.
`int` | `length(FSCoder coder)`
`void` | `setData(byte[] data)` Sets the encoded video data.
`void` | `setFrameNumber(int number)` Sets the number of the frame.
`void` | `setIdentifier(int anIdentifier)` Sets the identifier of the FSDefineVideo object where the frame will be displayed.

Methods inherited from class com.flagstone.transform.FSMovieObject
`getType`

Methods inherited from class com.flagstone.transform.FSTransformObject
`name, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### FSVideoFrame

    public FSVideoFrame(FSCoder coder)

  Construct an FSVideoFrame object, initialising it with values decoded from an encoded object.

  Parameters:
    `coder` - an FSCoder containing the binary data.

### FSVideoFrame

    public FSVideoFrame(int anIdentifier,
                        int frameNumber,
                        byte[] data)

  Constructs a new FSVideoFrame object which will display the specified frame of video data in the FSDefineVideo object that matches the identifier.

  Parameters:
    `anIdentifier` - the unique identifier of the FSDefineVideo object.
    `frameNumber` - the number of the frame.
    `data` - the encoded video data. For Flash 6 this is encoded in the H263 format. In Flash 7 H263 and ScreenVideo is supported.

### FSVideoFrame

    public FSVideoFrame(FSVideoFrame obj)

  Constructs an FSVideoFrame object by copying values from an existing object.

  Parameters:
    `obj` - an FSVideoFrame object.

Method Detail

### getIdentifier

    public int getIdentifier()

  Get the identifier of the FSDefineVideo object where the frame will be displayed.

  Returns:
    the unique identifier of the FSDefineVideo object.

### setIdentifier

    public void setIdentifier(int anIdentifier)

  Sets the identifier of the FSDefineVideo object where the frame will be displayed.

  Parameters:
    `anIdentifier` - the unique identifier of the FSDefineVideo object.

### getFrameNumber

    public int getFrameNumber()

  Gets the number of the frame.

  Returns:
    the frame number.

### setFrameNumber

    public void setFrameNumber(int number)

  Sets the number of the frame.

  Parameters:
    `number` - the frame number.

### getData

    public byte[] getData()

  Gets the encoded video data. In Flash 6 modified H263 encoded video is supported. Flash 7 supports both modified H263 and ScreenVideo.

  Returns:
    the encoded video data.

### setData

    public void setData(byte[] data)

  Sets the encoded video data. In Flash 6 modified H263 encoded video is supported. Flash 7 supports both modified H263 and ScreenVideo,

  Parameters:
    `data` - the encoded video data.

### clone

    public java.lang.Object clone()

  Description copied from class: `FSTransformObject`
  Creates a deep copy of the entire object.

  Overrides:
    `clone` in class `FSTransformObject`
  Returns:
    a copy of the object.

### equals

    public boolean equals(java.lang.Object anObject)

  Description copied from class: `FSMovieObject`
  Returns true if anObject is equal to this one. Objects are considered equal if they would generate identical binary data when they are encoded to a Flash file.

  Overrides:
    `equals` in class `FSMovieObject`
  Returns:
    true if this object would be identical to anObject when encoded.

### appendDescription

    public void appendDescription(java.lang.StringBuffer buffer,
                                  int depth)

  Description copied from class: `FSTransformObject`
  AppendDescription is used to present a string description of the object including all nested objects up to a specified depth. This method provide a more controlled way of creating a string representation of an object since large objects such as font or shape definitions can contain dozens of nested objects. The representation of the object is appended to the StringBuffer, showing the name of the class and values of the attributes it contains. If the object contains any attributes that are objects then the object graph will be traversed up to the specified depth. If objects are nested at a level less than specified depth then the full string representation of the object is displayed. For objects at the specified depth only the name of the class is displayed. Any objects below this depth are not displayed.

  Overrides:
    `appendDescription` in class `FSMovieObject`
  Parameters:
    `buffer` - a StringBuffer to which the description of each object is appended.
    `depth` - the maximum level of nesting up to which objects will be displayed.

### length

    public int length(FSCoder coder)

  Overrides:
    `length` in class `FSMovieObject`

### encode

    public void encode(FSCoder coder)

  Overrides:
    `encode` in class `FSMovieObject`

### decode

    public void decode(FSCoder coder)

  Overrides:
    `decode` in class `FSMovieObject`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD